=== extras/CMakeLists.txt ===

add_subdirectory(doc EXCLUDE_FROM_ALL)
add_subdirectory(packaging EXCLUDE_FROM_ALL)
add_subdirectory(benchmark)
