=== extras/packaging/PKGBUILD ===
# Maintainer: Marco Poletti <poletti.marco@gmail.com>
pkgname=libfruit
pkgver=@Fruit_VERSION@
pkgrel=0
pkgdesc="Fruit is a dependency injection framework for C++."
url="https://github.com/google/fruit"
arch=('x86_64' 'i686')
license=('Apache')
depends=('cmake' 'boost' 'gcc>=5.0.0')
optdepends=()
makedepends=()
conflicts=()
replaces=()
backup=()
install='libfruit.install'
source=("fruit-${pkgver}.tar.gz")
md5sums=('d66cc12861e105cc38e5b878776f9f79')

build() {
  cd "${srcdir}/fruit-${pkgver}"
  cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=RelWithDebInfo .
  make
}

package() {
  cd "${srcdir}/fruit-${pkgver}"
  make DESTDIR="${pkgdir}" install
}

# vim:set ts=2 sw=2 et:
